﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp2_androidPassword
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        static Random R = new Random();
        string masterPassword = "01258";
        string currentPassword = String.Empty;
        bool active = false;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            SizeToContent = SizeToContent.WidthAndHeight;
            myGrid.Width = 300;
            myGrid.Height = 300;
            for (int y = 0; y < 3; y++)
            {
                myGrid.RowDefinitions.Add(new RowDefinition());
                myGrid.ColumnDefinitions.Add(new ColumnDefinition());
                for (int x = 0; x < 3; x++)
                {
                    Label newlabel = new Label();
                    newlabel.Content = (y * 3 + x).ToString();
                    newlabel.FontSize = 50;
                    newlabel.BorderBrush = Brushes.Black; // new SolidColorBrush() 
                    newlabel.BorderThickness = new Thickness(3);
                    newlabel.Background = Brushes.Cyan;
                    newlabel.Margin = new Thickness(10);
                    newlabel.HorizontalContentAlignment = HorizontalAlignment.Center;
                    newlabel.VerticalContentAlignment = VerticalAlignment.Center;

                    // <Label Grid.Row="1" Grid.Column="2" MouseMove="xxxMethod"
                    Grid.SetColumn(newlabel, x);
                    Grid.SetRow(newlabel, y);
                    newlabel.MouseMove += newlabel_MouseMove;

                    myGrid.Children.Add(newlabel);
                }
            }
        }
        void newlabel_MouseMove(object sender, MouseEventArgs e)
        {
            (sender as Label).BorderBrush = new SolidColorBrush(Color.FromRgb(
                (byte)R.Next(0, 256), (byte)R.Next(0, 256), (byte)R.Next(0, 256)));
        }
        private void myGrid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            active = true;
            currentPassword = String.Empty;
        }
        private void myGrid_MouseMove(object sender, MouseEventArgs e)
        {
            // e.LeftButton
            if (active && e.Source is Label)
            {
                Label L = e.Source as Label;
                char c = L.Content.ToString()[0];
                // if (!currentPassword.Contains(c)
                if (currentPassword == String.Empty || c != currentPassword[currentPassword.Length - 1])
                {
                    currentPassword += c;
                    L.Background = Brushes.Yellow;
                    this.Title = currentPassword;
                }
            }
        }
        private void myGrid_MouseUp(object sender, MouseButtonEventArgs e)
        {
            active = false;
            if (currentPassword == masterPassword)
            {
                MessageBox.Show("GOOD PASSWORD");
            }
            else
            {
                MessageBox.Show("BAD PASSWORD: " + currentPassword);
            }
            foreach (UIElement element in (sender as Grid).Children)
            {
                if (element is Label)
                {
                    (element as Label).Background = Brushes.Cyan;
                    (element as Label).BorderBrush = Brushes.Black;
                }
            }
        }

    }
}
